
    /*!
    * structured-editor-ui v0.1.5
    * (c) 2019 HollyIT (limited liability)
    * @license MIT
    */
  
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('popper.js'), require('@ledecmf/editor-core'), require('prosemirror-commands'), require('@ledecmf/structured-editor'), require('v-click-outside'), require('prosemirror-utils'), require('@ledecmf/structured-editor-extensions'), require('@ledecmf/structured-editor-utils')) :
    typeof define === 'function' && define.amd ? define(['exports', 'popper.js', '@ledecmf/editor-core', 'prosemirror-commands', '@ledecmf/structured-editor', 'v-click-outside', 'prosemirror-utils', '@ledecmf/structured-editor-extensions', '@ledecmf/structured-editor-utils'], factory) :
    (global = global || self, factory(global.structuredEditorUI = {}, global.Popper, global.editorCore, global.prosemirrorCommands, global.structuredEditor, global.vClickOutside, global.prosemirrorUtils, global.structuredEditorExtensions, global.structuredEditorUtils));
}(this, function (exports, Popper, editorCore, prosemirrorCommands, structuredEditor, vClickOutside, prosemirrorUtils, structuredEditorExtensions, structuredEditorUtils) { 'use strict';

    Popper = Popper && Popper.hasOwnProperty('default') ? Popper['default'] : Popper;
    vClickOutside = vClickOutside && vClickOutside.hasOwnProperty('default') ? vClickOutside['default'] : vClickOutside;

    //
    var script = {
      name: 'MenuItem',
      components: {
        EditorButton: editorCore.EditorButton
      },
      props: {
        item: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        showLabel: Boolean
      },
      methods: {
        extensionCommand: function extensionCommand(item) {
          item.command(this.editor);
          this.$emit('exec', item);
        }
      },
      mounted: function mounted() {}
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
    /* server only */
    , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
      if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
      } // Vue.extend constructor export interop.


      var options = typeof script === 'function' ? script.options : script; // render functions

      if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true; // functional template

        if (isFunctionalTemplate) {
          options.functional = true;
        }
      } // scopedId


      if (scopeId) {
        options._scopeId = scopeId;
      }

      var hook;

      if (moduleIdentifier) {
        // server build
        hook = function hook(context) {
          // 2.3 injection
          context = context || // cached call
          this.$vnode && this.$vnode.ssrContext || // stateful
          this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
          // 2.2 with runInNewContext: true

          if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
            context = __VUE_SSR_CONTEXT__;
          } // inject component styles


          if (style) {
            style.call(this, createInjectorSSR(context));
          } // register component module identifier for async chunk inference


          if (context && context._registeredComponents) {
            context._registeredComponents.add(moduleIdentifier);
          }
        }; // used by ssr in case component is cached and beforeCreate
        // never gets called


        options._ssrRegister = hook;
      } else if (style) {
        hook = shadowMode ? function () {
          style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
        } : function (context) {
          style.call(this, createInjector(context));
        };
      }

      if (hook) {
        if (options.functional) {
          // register for functional component in vue file
          var originalRender = options.render;

          options.render = function renderWithStyleInjection(h, context) {
            hook.call(context);
            return originalRender(h, context);
          };
        } else {
          // inject component registration as beforeCreate hook
          var existing = options.beforeCreate;
          options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
      }

      return script;
    }

    var normalizeComponent_1 = normalizeComponent;

    /* script */
    const __vue_script__ = script;

    /* template */
    var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"menu-item"},[(_vm.item.component)?_c(_vm.item.component,{tag:"component",attrs:{"item":_vm.item,"editor":_vm.editor,"show-label":_vm.showLabel},on:{"exec":function($event){return _vm.$emit('exec', _vm.item)}}}):(_vm.item.isAvailable(_vm.editor))?_c('editor-button',{attrs:{"show-label":_vm.showLabel,"icon":_vm.item.icon,"label":_vm.item.label,"active":_vm.item.isActive(_vm.editor)},on:{"click":function($event){return _vm.extensionCommand(_vm.item)}}}):_vm._e()],1)};
    var __vue_staticRenderFns__ = [];

      /* style */
      const __vue_inject_styles__ = undefined;
      /* scoped */
      const __vue_scope_id__ = "data-v-f85f8da0";
      /* module identifier */
      const __vue_module_identifier__ = undefined;
      /* functional template */
      const __vue_is_functional_template__ = false;
      /* style inject */
      
      /* style inject SSR */
      

      
      var MenuItem = normalizeComponent_1(
        { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
        __vue_inject_styles__,
        __vue_script__,
        __vue_scope_id__,
        __vue_is_functional_template__,
        __vue_module_identifier__,
        undefined,
        undefined
      );

    //
    var script$1 = {
      name: 'BlockMenu',
      components: {
        EditorButton: editorCore.EditorButton,
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          top: 0,
          only: null,
          isActive: false,
          left: 0
        };
      },
      mounted: function mounted() {
        this.$editor.$on('selection', this.onSelection);
      },
      beforeDestroy: function beforeDestroy() {
        this.hide();
        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        onExec: function onExec() {
          this.hide();
        },
        onSelection: function onSelection(selection) {
          this.selection = selection;
          var state = selection.view.state;
          var parent = this.$editor.$el.parentNode;
          var editorBoundings = parent.getBoundingClientRect();
          var cursorBoundings = selection.view.coordsAtPos(state.selection.$anchor.pos);
          var currentDom = selection.view.domAtPos(state.selection.$anchor.pos);

          if (currentDom && currentDom.node && currentDom.node.getBoundingClientRect) {
            var domOffset = currentDom.node.getBoundingClientRect();
            this.top = cursorBoundings.top - editorBoundings.top;
            this.left = domOffset.x - editorBoundings.left - 36;
          }
        },
        open: function open() {
          var _this = this;

          this.$editor.focus();
          this.isActive = true;
          this.$nextTick(function () {
            _this.popper = new Popper(_this.$refs.toggle, _this.$refs.toolbar, {
              placement: 'bottom-start'
            });
          });
          document.addEventListener('mousedown', this.maybeHide);
        },
        toggle: function toggle() {
          if (this.isActive) {
            this.hide();
          } else {
            this.open();
          }
        },
        hide: function hide() {
          if (this.popper) {
            this.popper.destroy();
            this.popper = null;
          }

          this.isActive = false;
          document.removeEventListener('mousedown', this.maybeHide);
        },
        maybeHide: function maybeHide(event) {
          if (!this.$el.contains(event.target)) {
            this.hide();
          }
        }
      }
    };

    var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
    function createInjector(context) {
      return function (id, style) {
        return addStyle(id, style);
      };
    }
    var HEAD = document.head || document.getElementsByTagName('head')[0];
    var styles = {};

    function addStyle(id, css) {
      var group = isOldIE ? css.media || 'default' : id;
      var style = styles[group] || (styles[group] = {
        ids: new Set(),
        styles: []
      });

      if (!style.ids.has(id)) {
        style.ids.add(id);
        var code = css.source;

        if (css.map) {
          // https://developer.chrome.com/devtools/docs/javascript-debugging
          // this makes source maps inside style tags work properly in Chrome
          code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

          code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
        }

        if (!style.element) {
          style.element = document.createElement('style');
          style.element.type = 'text/css';
          if (css.media) style.element.setAttribute('media', css.media);
          HEAD.appendChild(style.element);
        }

        if ('styleSheet' in style.element) {
          style.styles.push(code);
          style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
        } else {
          var index = style.ids.size - 1;
          var textNode = document.createTextNode(code);
          var nodes = style.element.childNodes;
          if (nodes[index]) style.element.removeChild(nodes[index]);
          if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
        }
      }
    }

    var browser = createInjector;

    /* script */
    const __vue_script__$1 = script$1;

    /* template */
    var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-block-menu",style:({'top' : _vm.top + 'px', 'left' : _vm.left + 'px'})},[_c('div',{ref:"toggle"},[_c('editor-button',{attrs:{"icon":"paragraph2"},on:{"click":_vm.toggle}})],1),_vm._v(" "),(_vm.isActive)?_c('div',{ref:"toolbar",staticClass:"menu-inner"},[_vm._l((_vm.items),function(item,idx){return [(!_vm.only || _vm.only === item)?_c('menu-item',{key:idx,attrs:{"item":item,"editor":_vm.editor},on:{"exec":_vm.onExec}}):_vm._e()]}),_vm._v(" "),_c('div',{staticClass:"menu-arrow",attrs:{"x-arrow":""}})],2):_vm._e()])};
    var __vue_staticRenderFns__$1 = [];

      /* style */
      const __vue_inject_styles__$1 = function (inject) {
        if (!inject) return
        inject("data-v-44cb0280_0", { source: ".lede-block-menu{position:absolute;z-index:100;width:24px;height:24px}.lede-block-menu .menu-inner{display:flex;border-radius:4px}.lede-block-menu .menu-inner button{display:inline-flex;align-items:center;padding:5px}.lede-block-menu .lede-block-selector{display:flex;align-items:center;height:100%;padding:5px}.lede-block-menu .lede-block-selector select{border-radius:.25rem;padding:0;height:28px}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$1 = undefined;
      /* module identifier */
      const __vue_module_identifier__$1 = undefined;
      /* functional template */
      const __vue_is_functional_template__$1 = false;
      /* style inject SSR */
      

      
      var BlockMenu = normalizeComponent_1(
        { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
        __vue_inject_styles__$1,
        __vue_script__$1,
        __vue_scope_id__$1,
        __vue_is_functional_template__$1,
        __vue_module_identifier__$1,
        browser,
        undefined
      );

    //
    var script$2 = {
      name: 'BlockTypeSelector',
      inject: ['$editor'],
      props: {
        editor: {
          type: Object,
          required: true
        },
        item: Object
      },
      computed: {
        types: function types() {
          return this.item.all();
        },
        activeBlock: {
          get: function get() {
            var _this = this;

            var active = null;
            this.types.forEach(function (type) {
              if (_this.editor.isActive[type.command] && _this.editor.isActive[type.command](type.attrs)) {
                active = type;
              }
            });
            return active;
          },
          set: function set(type) {
            this.editor.commands[type.command](type.attrs);
          }
        }
      }
    };

    /* script */
    const __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$2 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-block-selector"},[_c('select',{directives:[{name:"model",rawName:"v-model",value:(_vm.activeBlock),expression:"activeBlock"}],on:{"change":function($event){var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return val}); _vm.activeBlock=$event.target.multiple ? $$selectedVal : $$selectedVal[0];}}},_vm._l((_vm.types),function(type,idx){return _c('option',{key:idx,domProps:{"value":type,"textContent":_vm._s(type.label)}})}),0)])};
    var __vue_staticRenderFns__$2 = [];

      /* style */
      const __vue_inject_styles__$2 = undefined;
      /* scoped */
      const __vue_scope_id__$2 = "data-v-3cb6679e";
      /* module identifier */
      const __vue_module_identifier__$2 = undefined;
      /* functional template */
      const __vue_is_functional_template__$2 = false;
      /* style inject */
      
      /* style inject SSR */
      

      
      var BlockTypeSelector = normalizeComponent_1(
        { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
        __vue_inject_styles__$2,
        __vue_script__$2,
        __vue_scope_id__$2,
        __vue_is_functional_template__$2,
        __vue_module_identifier__$2,
        undefined,
        undefined
      );

    //
    var script$3 = {
      name: 'EditorDialog',
      components: {
        EditorButton: editorCore.EditorButton
      }
    };

    /* script */
    const __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$3 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('transition',{attrs:{"name":"lede-editor-dialog"}},[_c('div',{staticClass:"lede-editor-dialog"},[_c('div',{staticClass:"dialog-window"},[_c('div',{staticClass:"dialog-header"},[_c('div',{staticClass:"inner"},[_vm._t("header")],2),_vm._v(" "),_c('div',{staticClass:"close"},[_c('editor-button',{attrs:{"icon":"close"},on:{"click":function($event){return _vm.$emit('close')}}})],1)]),_vm._v(" "),_c('div',{staticClass:"dialog-body"},[_vm._t("default")],2),_vm._v(" "),(_vm.$slots.actions)?_c('div',{staticClass:"dialog-footer"},[_vm._t("actions")],2):_vm._e()])])])};
    var __vue_staticRenderFns__$3 = [];

      /* style */
      const __vue_inject_styles__$3 = function (inject) {
        if (!inject) return
        inject("data-v-7e662d3b_0", { source: ".lede-editor-dialog-enter,.lede-editor-dialog-leave-active{opacity:0}.lede-editor-dialog-enter-active,.lede-editor-dialog-leave-active{transition:opacity .25s ease}.lede-editor-dialog{z-index:500;position:fixed;top:0;left:0;right:0;bottom:0;background:rgba(0,0,0,.3);display:flex;align-items:center;justify-content:center}.lede-editor-dialog .dialog-window{background:#fff;border-radius:4px;max-height:95%;display:flex;flex-direction:column}.lede-editor-dialog .dialog-header{padding:15px;font-size:16px;font-weight:700;border-bottom:1px solid #ccc;display:flex;align-items:center}.lede-editor-dialog .dialog-header .inner{flex:1}.lede-editor-dialog .dialog-body{overflow:auto;padding:15px;flex:1}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$3 = undefined;
      /* module identifier */
      const __vue_module_identifier__$3 = undefined;
      /* functional template */
      const __vue_is_functional_template__$3 = false;
      /* style inject SSR */
      

      
      var EditorDialog = normalizeComponent_1(
        { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
        __vue_inject_styles__$3,
        __vue_script__$3,
        __vue_scope_id__$3,
        __vue_is_functional_template__$3,
        __vue_module_identifier__$3,
        browser,
        undefined
      );

    //
    var script$4 = {
      name: 'InsertDialog',
      inject: ['$editor'],
      components: {
        MenuItem: MenuItem,
        EditorDialog: EditorDialog,
        EditorButton: editorCore.EditorButton,
        EditorIcon: editorCore.EditorIcon
      },
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          showItems: false
        };
      },
      methods: {
        insert: function insert(item) {
          item.command(this.editor);
          this.showItems = false;
        }
      }
    };

    /* script */
    const __vue_script__$4 = script$4;

    /* template */
    var __vue_render__$4 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"node-insert-dialog"},[_c('editor-button',{attrs:{"icon":"add","label":"Browse more blocks"},on:{"click":function($event){_vm.showItems=true;}}}),_vm._v(" "),_c('editor-dialog',{directives:[{name:"show",rawName:"v-show",value:(_vm.showItems),expression:"showItems"}],on:{"close":function($event){_vm.showItems=false;}},scopedSlots:_vm._u([{key:"header",fn:function(){return [_vm._v("Insert new block")]},proxy:true}])},[_vm._v(" "),_c('div',{staticClass:"insert-items"},_vm._l((_vm.items),function(item){return _c('div',{staticClass:"insert-item"},[_c('menu-item',{attrs:{"show-label":true,"item":item,"editor":_vm.editor},on:{"exec":function($event){_vm.showItems = false;}}})],1)}),0)])],1)};
    var __vue_staticRenderFns__$4 = [];

      /* style */
      const __vue_inject_styles__$4 = function (inject) {
        if (!inject) return
        inject("data-v-5d1236be_0", { source: ".node-insert-dialog .insert-items{min-width:250px}.node-insert-dialog .insert-item{margin:10px 0;align-items:center;cursor:pointer}.node-insert-dialog .insert-item button{text-align:left}.node-insert-dialog .insert-item .menu-item{width:100%;display:block}.node-insert-dialog .insert-item .editor-icon{margin-right:15px}.node-insert-dialog .insert-item .lede-editor-button{display:flex;align-items:center;width:100%;padding:10px 5px}.node-insert-dialog .insert-item .lede-editor-button:hover{background:#2cb5ff;color:#fff}.node-insert-dialog .insert-item .lede-editor-button:hover svg{fill:#fff}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$4 = undefined;
      /* module identifier */
      const __vue_module_identifier__$4 = undefined;
      /* functional template */
      const __vue_is_functional_template__$4 = false;
      /* style inject SSR */
      

      
      var InsertDialog = normalizeComponent_1(
        { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
        __vue_inject_styles__$4,
        __vue_script__$4,
        __vue_scope_id__$4,
        __vue_is_functional_template__$4,
        __vue_module_identifier__$4,
        browser,
        undefined
      );

    //
    var script$5 = {
      name: 'InsertMenu',
      components: {
        InsertDialog: InsertDialog,
        EditorButton: editorCore.EditorButton,
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      computed: {
        quick: function quick() {
          return this.menu.quickItems();
        }
      },
      data: function data() {
        return {
          left: 0,
          isActive: false,
          top: 0,
          collapsed: false
        };
      },
      mounted: function mounted() {
        var _this = this;

        this.$editor.$on('selection', this.onSelection);
        this.$nextTick(function () {
          _this.onSelection(new structuredEditor.SelectionEvent(_this.$editor.tiptap.view));
        });
      },
      beforeDestroy: function beforeDestroy() {
        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        /**
         *
         * @param {SelectionEvent} selection
         */
        onSelection: function onSelection(selection) {
          var _this2 = this;

          var state = selection.view.state;
          var currentDom = selection.view.domAtPos(state.selection.$anchor.pos);
          this.isActive = currentDom.node.innerHTML === '<br>' && currentDom.node.tagName === 'P';

          if (this.isActive) {
            var ownerPos = currentDom.node.getBoundingClientRect();
            this.collapsed = false;

            if (this.menu.settings.collapse && currentDom.node.offsetWidth <= this.menu.settings.collapse) {
              this.collapsed = true;
            }

            var parent = this.$editor.$el.parentNode;
            var editorBounds = parent.getBoundingClientRect();
            var cursorBounds = selection.view.coordsAtPos(state.selection.$anchor.pos);
            this.top = cursorBounds.top - editorBounds.top;
            this.$nextTick(function () {
              _this2.left = ownerPos.x - editorBounds.x + currentDom.node.offsetWidth - _this2.$el.offsetWidth;
            });
          }
        }
      }
    };

    /* script */
    const __vue_script__$5 = script$5;

    /* template */
    var __vue_render__$5 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-insert-menu",style:({top: _vm.top + 'px', left: _vm.left+ 'px'})},[(_vm.isActive)?_c('div',{staticClass:"menu-inner"},[_vm._l((_vm.quick),function(item,idx){return (!_vm.collapsed)?[_c('menu-item',{key:idx,attrs:{"item":item,"editor":_vm.editor}})]:_vm._e()}),_vm._v(" "),_c('insert-dialog',{attrs:{"menu":_vm.menu,"editor":_vm.editor}})],2):_vm._e()])};
    var __vue_staticRenderFns__$5 = [];

      /* style */
      const __vue_inject_styles__$5 = function (inject) {
        if (!inject) return
        inject("data-v-c1c332b6_0", { source: ".lede-insert-menu{position:absolute;display:inline-block;z-index:10}.lede-insert-menu .menu-inner{display:flex}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$5 = undefined;
      /* module identifier */
      const __vue_module_identifier__$5 = undefined;
      /* functional template */
      const __vue_is_functional_template__$5 = false;
      /* style inject SSR */
      

      
      var InsertMenu = normalizeComponent_1(
        { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
        __vue_inject_styles__$5,
        __vue_script__$5,
        __vue_scope_id__$5,
        __vue_is_functional_template__$5,
        __vue_module_identifier__$5,
        browser,
        undefined
      );

    //
    var script$6 = {
      name: 'MenuDropButton',
      components: {
        EditorButton: editorCore.EditorButton
      },
      directives: {
        clickOutside: vClickOutside.directive
      },
      inject: ['$menu', '$editor'],
      props: {
        item: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        showLabel: Boolean
      },
      data: function data() {
        return {
          opened: false,
          fromMenu: false
        };
      },
      beforeDestroy: function beforeDestroy() {
        this.destroyPopper();
      },
      methods: {
        destroyPopper: function destroyPopper() {
          if (this.popper) {
            this.popper.destroy();
            this.popper = null;
          }
        },
        open: function open() {
          var _this = this;

          if (this.$editor.showMenu) {
            this.fromMenu = true;
            this.destroyPopper();
            this.$nextTick(function () {
              _this.popper = new Popper(_this.$el, _this.$refs.body, {
                'placement': 'bottom'
              });
            });
          } else {
            this.$menu.showOnly(this.item);
            this.fromMenu = false;
          }

          this.opened = true;
          this.$emit('opened');
        },
        close: function close() {
          if (this.$editor.showMenu) {
            this.destroyPopper();
          } else {
            this.$menu.showOnly();
          }

          this.opened = false;
          this.$emit('closed');
        },
        toggle: function toggle() {
          if (this.opened) {
            this.close();
          } else {
            this.open();
          }
        }
      }
    };

    /* script */
    const __vue_script__$6 = script$6;

    /* template */
    var __vue_render__$6 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"menu-drop-button",class:{'from-menu' : _vm.fromMenu}},[_c('editor-button',{ref:"button",attrs:{"label":_vm.item.label,"show-label":_vm.showLabel,"icon":_vm.item.icon},on:{"click":_vm.toggle}}),_vm._v(" "),_c('div',{ref:"body",staticClass:"button-body"},[(_vm.opened)?_c('div',{directives:[{name:"click-outside",rawName:"v-click-outside",value:(_vm.close),expression:"close"}]},[_vm._t("default"),_vm._v(" "),(_vm.fromMenu)?_c('div',{attrs:{"x-arrow":""}}):_vm._e()],2):_vm._e()])],1)};
    var __vue_staticRenderFns__$6 = [];

      /* style */
      const __vue_inject_styles__$6 = undefined;
      /* scoped */
      const __vue_scope_id__$6 = undefined;
      /* module identifier */
      const __vue_module_identifier__$6 = undefined;
      /* functional template */
      const __vue_is_functional_template__$6 = false;
      /* style inject */
      
      /* style inject SSR */
      

      
      var MenuDropButton = normalizeComponent_1(
        { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
        __vue_inject_styles__$6,
        __vue_script__$6,
        __vue_scope_id__$6,
        __vue_is_functional_template__$6,
        __vue_module_identifier__$6,
        undefined,
        undefined
      );

    //
    //
    //
    //
    var script$7 = {
      name: 'MenuSeparator'
    };

    /* script */
    const __vue_script__$7 = script$7;

    /* template */
    var __vue_render__$7 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"menu-separator"})};
    var __vue_staticRenderFns__$7 = [];

      /* style */
      const __vue_inject_styles__$7 = undefined;
      /* scoped */
      const __vue_scope_id__$7 = "data-v-14578869";
      /* module identifier */
      const __vue_module_identifier__$7 = undefined;
      /* functional template */
      const __vue_is_functional_template__$7 = false;
      /* style inject */
      
      /* style inject SSR */
      

      
      var MenuSeparator = normalizeComponent_1(
        { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
        __vue_inject_styles__$7,
        __vue_script__$7,
        __vue_scope_id__$7,
        __vue_is_functional_template__$7,
        __vue_module_identifier__$7,
        undefined,
        undefined
      );

    //
    var script$8 = {
      name: 'SelectionMenu',
      components: {
        MenuItem: MenuItem
      },
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      inject: ['$editor'],
      props: {
        menu: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        }
      },
      watch: {
        active: function active(val) {
          if (this.popper && !val) {
            this.popper.destroy();
            this.popper = null;
          }
        }
      },
      computed: {
        items: function items() {
          return this.menu.all();
        }
      },
      data: function data() {
        return {
          active: false,
          style: {},
          only: null
        };
      },
      mounted: function mounted() {
        this.showDebounce = null;
        this.$editor.$on('selection', this.onSelection);
      },
      beforeDestroy: function beforeDestroy() {
        this.hide();

        if (this.showDebounce) {
          clearTimeout(this.showDebounce);
        }

        this.$editor.$off('selection', this.onSelection);
      },
      methods: {
        showOnly: function showOnly(item) {
          var _this = this;

          this.only = item;
          this.$nextTick(function () {
            if (_this.popper) {
              _this.popper.update();
            }
          });
        },
        onSelection: function onSelection(selection) {
          var _this2 = this;

          if (this.showDebounce) {
            clearTimeout(this.showDebounce);
          }

          this.hide();

          if (!selection.empty && (selection.type === 'text' || selection.type === 'node' && selection.node.type.isInline)) {
            this.showDebounce = setTimeout(function () {
              if (!selection.empty) {
                _this2.show(selection);
              }
            }, 100);
          }
        },
        hide: function hide() {
          this.active = false;
          document.removeEventListener('mousedown', this.maybeHide);
          this.only = null;
        },
        maybeHide: function maybeHide(event) {
          if (!this.$el.contains(event.target)) {
            this.hide();
          }
        },
        show: function show(selection) {
          var _this3 = this;

          document.addEventListener('mousedown', this.maybeHide);
          this.active = true;
          var parent = this.$editor.$el;
          var box = parent.getBoundingClientRect();
          var left = 0,
              bottom = 0;
          left = Math.max((selection.box.start.left + selection.box.end.left) / 2, selection.box.start.left + 3);
          left = parseInt(left - box.left, 10);
          bottom = selection.box.start.top;
          this.style = {
            left: left + 'px',
            bottom: parseInt(box.bottom - bottom, 10) + 'px'
          };
          this.$nextTick(function () {
            var anchor = _this3.$refs.marker;
            _this3.popper = new Popper(anchor, _this3.$refs.menu, {
              placement: 'top',
              offset: 0
            }); //  document.addEventListener('mousedown', this.checkMouse);
          });
        }
      }
    };

    /* script */
    const __vue_script__$8 = script$8;

    /* template */
    var __vue_render__$8 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-selection-menu",style:(_vm.style)},[_c('div',{ref:"marker",staticClass:"selection-marker"}),_vm._v(" "),(_vm.active)?_c('div',{ref:"menu",staticClass:"menu-inner"},[_vm._l((_vm.items),function(item,idx){return [(!_vm.only || _vm.only === item)?_c('menu-item',{key:idx,attrs:{"item":item,"editor":_vm.editor}}):_vm._e()]}),_vm._v(" "),_c('div',{staticClass:"menu-arrow",attrs:{"x-arrow":""}})],2):_vm._e()])};
    var __vue_staticRenderFns__$8 = [];

      /* style */
      const __vue_inject_styles__$8 = function (inject) {
        if (!inject) return
        inject("data-v-7d3ed23c_0", { source: ".lede-selection-menu{position:absolute;z-index:100}.lede-selection-menu .selection-marker{position:absolute;width:0;height:0}.lede-selection-menu .menu-inner{display:inline-flex;border-radius:4px}.lede-selection-menu button{display:inline-flex;align-items:center;padding:5px}.menu-drop-button{display:flex}.menu-drop-button .button-body{display:flex}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$8 = undefined;
      /* module identifier */
      const __vue_module_identifier__$8 = undefined;
      /* functional template */
      const __vue_is_functional_template__$8 = false;
      /* style inject SSR */
      

      
      var SelectionMenu = normalizeComponent_1(
        { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
        __vue_inject_styles__$8,
        __vue_script__$8,
        __vue_scope_id__$8,
        __vue_is_functional_template__$8,
        __vue_module_identifier__$8,
        browser,
        undefined
      );

    //

    function addMenuItems(items, newItems) {
      var labels = [];
      items.forEach(function (item) {
        labels.push(item.label + item.icon);
      });
      newItems.forEach(function (item) {
        if (labels.indexOf(item.label + item.icon) < 0) {
          items.push(item);
        }
      });
      return items;
    }

    var script$9 = {
      name: 'MenuBar',
      components: {
        InsertDialog: InsertDialog,
        MenuItem: MenuItem
      },
      inject: ['$editor'],
      provide: function provide() {
        return {
          '$menu': this
        };
      },
      props: {
        config: {
          type: Object,
          required: true
        },
        editor: {
          type: Object,
          required: true
        },
        settings: {
          type: Object,
          required: true
        }
      },
      computed: {
        items: function items() {
          var items = [];
          items = addMenuItems(items, this.config.selectionMenu.all());
          items = addMenuItems(items, this.config.insertMenu.quickItems());
          items.push('insert-dialog');
          items = addMenuItems(items, this.config.blockMenu.all());
          return items;
        },
        width: function width() {
          if (this.isStuck) {
            return this.$el.getBoundingClientRect().width + 'px';
          }

          return '100%';
        }
      },
      watch: {
        isStuck: function isStuck(val, oldVal) {
          if (val) {
            this.$editor.$el.style['padding-top'] = this.$el.clientHeight + 'px';
          } else {
            this.$editor.$el.style['padding-top'] = 0;
          }
        }
      },
      data: function data() {
        return {
          isStuck: false
        };
      },
      mounted: function mounted() {
        var el = typeof this.settings.scrollElement === 'string' ? document.querySelector(this.settings.scrollElement) : this.settings.scrollElement;
        el.addEventListener('scroll', this.watchScroll);
      },
      methods: {
        watchScroll: function watchScroll(e) {
          if (this.$editor.$el.getBoundingClientRect().top < this.settings.offset) {
            this.isStuck = true;
          } else {
            this.isStuck = false;
          }
        }
      }
    };

    /* script */
    const __vue_script__$9 = script$9;

    /* template */
    var __vue_render__$9 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-editor-menu-bar",class:{'is-stuck' : _vm.isStuck},style:({top: _vm.isStuck ? _vm.settings.offset + 'px' : 'auto', width: _vm.width})},[_c('div',{ref:"menu",staticClass:"menu-inner"},[_vm._l((_vm.items),function(item,idx){return [(item === 'insert-dialog')?_c('insert-dialog',{attrs:{"menu":_vm.config.insertMenu,"editor":_vm.editor}}):_c('menu-item',{key:idx,attrs:{"item":item,"editor":_vm.editor}})]})],2)])};
    var __vue_staticRenderFns__$9 = [];

      /* style */
      const __vue_inject_styles__$9 = function (inject) {
        if (!inject) return
        inject("data-v-14879f40_0", { source: ".lede-editor-menu-bar.is-stuck{position:fixed}.lede-editor-menu-bar .menu-inner{display:flex;flex-wrap:wrap;align-items:center}.lede-editor-menu-bar .menu-arrow{display:none}.lede-editor-menu-bar select{border-radius:.25rem;padding:0;height:28px}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$9 = undefined;
      /* module identifier */
      const __vue_module_identifier__$9 = undefined;
      /* functional template */
      const __vue_is_functional_template__$9 = false;
      /* style inject SSR */
      

      
      var MenuBar = normalizeComponent_1(
        { render: __vue_render__$9, staticRenderFns: __vue_staticRenderFns__$9 },
        __vue_inject_styles__$9,
        __vue_script__$9,
        __vue_scope_id__$9,
        __vue_is_functional_template__$9,
        __vue_module_identifier__$9,
        browser,
        undefined
      );

    //
    var script$a = {
      name: 'NodeResizer',
      props: {
        enabled: {
          type: Boolean,
          default: false
        },
        min: {
          type: Number
        },
        max: {
          type: Number
        }
      },
      data: function data() {
        return {
          sides: ['top', 'right', 'bottom', 'left'],
          resizing: false
        };
      },
      methods: {
        startResize: function startResize(e) {
          this.startPos = event.x;
          this.width = parseInt(getComputedStyle(this.$el).width);
          editorCore.addEvent(document.documentElement, 'mousemove', this.doDrag);
          editorCore.addEvent(document.documentElement, 'mouseup', this.stopDrag);
          this.resizing = true;
          this.$emit('resizeStart');
        },
        stop: function stop() {
          var _this = this;

          editorCore.removeEvent(document.documentElement, 'mousemove', this.doDrag);
          editorCore.removeEvent(document.documentElement, 'mouseup', this.stopDrag);
          this.$nextTick(function () {
            _this.resizing = false;

            _this.$emit('resize-stop');
          });
        },
        doDrag: function doDrag(event) {
          var dx = this.startPos - event.x;
          var newSize = this.width + dx;

          if (this.min && newSize < this.min) {
            return;
          }

          if (this.max && newSize > this.max) {
            return;
          }

          this.$emit('update', newSize);
        },
        stopDrag: function stopDrag(event) {
          this.stop();
        }
      }
    };

    /* script */
    const __vue_script__$a = script$a;

    /* template */
    var __vue_render__$a = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"lede-node-resizer"},[_vm._t("default"),_vm._v(" "),(_vm.enabled)?_vm._l((_vm.sides),function(side){return _c('div',{staticClass:"resize-handle",class:'resize-handle-' + side,on:{"mousedown":function($event){$event.stopPropagation();$event.preventDefault();return _vm.startResize($event)}}})}):_vm._e()],2)};
    var __vue_staticRenderFns__$a = [];

      /* style */
      const __vue_inject_styles__$a = function (inject) {
        if (!inject) return
        inject("data-v-4ae88262_0", { source: ".lede-node-resizer{position:relative}.lede-node-resizer .resize-handle{width:18px;height:18px;position:absolute;border-radius:50%;background:#4f8aff;border:2px solid #fff}.lede-node-resizer .resize-handle.resize-handle-left{left:-9px;top:50%}.lede-node-resizer .resize-handle.resize-handle-right{right:-9px;top:50%}.lede-node-resizer .resize-handle.resize-handle-top{top:-9px;left:50%}.lede-node-resizer .resize-handle.resize-handle-bottom{bottom:-9px;left:50%}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$a = undefined;
      /* module identifier */
      const __vue_module_identifier__$a = undefined;
      /* functional template */
      const __vue_is_functional_template__$a = false;
      /* style inject SSR */
      

      
      var NodeResizer = normalizeComponent_1(
        { render: __vue_render__$a, staticRenderFns: __vue_staticRenderFns__$a },
        __vue_inject_styles__$a,
        __vue_script__$a,
        __vue_scope_id__$a,
        __vue_is_functional_template__$a,
        __vue_module_identifier__$a,
        browser,
        undefined
      );

    //
    var script$b = {
      name: 'NodeOptions',
      components: {
        NodeResizer: NodeResizer,
        EditorButton: editorCore.EditorButton
      },
      props: {
        selected: Boolean,
        value: {
          type: String
        },
        options: {
          type: Object
        }
      },
      computed: {
        notAligned: function notAligned() {
          return this.value !== 'left' && this.value !== 'right' && this.value !== 'center';
        }
      }
    };

    /* script */
    const __vue_script__$b = script$b;

    /* template */
    var __vue_render__$b = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"node-has-options",class:{'is-selected' : _vm.selected},attrs:{"lede-align":_vm.value}},[_c('div',{staticClass:"options-inner"},[_vm._t("default"),_vm._v(" "),(_vm.selected)?_c('div',{staticClass:"node-options"},[(_vm.options)?[(!_vm.notAligned)?_c('editor-button',{attrs:{"icon":"align_justify","label":"Align none"},on:{"click":function($event){return _vm.$emit('input', '')}}}):_vm._e(),_vm._v(" "),(_vm.value !== 'left')?_c('editor-button',{attrs:{"icon":"align_left","label":"Align left"},on:{"click":function($event){return _vm.$emit('input', 'left')}}}):_vm._e(),_vm._v(" "),(_vm.value !== 'center')?_c('editor-button',{attrs:{"icon":"align_center","label":"Align center"},on:{"click":function($event){return _vm.$emit('input', 'center')}}}):_vm._e(),_vm._v(" "),(_vm.value !== 'right')?_c('editor-button',{attrs:{"icon":"align_right","label":"Align right"},on:{"click":function($event){return _vm.$emit('input', 'right')}}}):_vm._e()]:_vm._e(),_vm._v(" "),_vm._t("options")],2):_vm._e()],2)])};
    var __vue_staticRenderFns__$b = [];

      /* style */
      const __vue_inject_styles__$b = function (inject) {
        if (!inject) return
        inject("data-v-3f939d01_0", { source: ".node-has-options{width:auto;margin:0 auto}.node-has-options .options-inner{position:relative}.node-has-options .node-options{background:#fff;border:1px solid #ccc;padding:5px;position:absolute;right:0;bottom:100%;display:flex;align-items:center}.node-has-options[lede-align=left]{width:100%;height:0;z-index:50}.node-has-options[lede-align=left] .options-inner{float:left}.node-has-options[lede-align=left] .node-options{left:0;right:auto}.node-has-options[lede-align=right]{width:100%;height:0;z-index:50}.node-has-options[lede-align=right] .options-inner{float:right}.node-has-options[lede-align=center]{display:flex;justify-content:center}.node-has-options[lede-align=center] .options-inner{display:inline-block;margin:0 auto}", map: undefined, media: undefined });

      };
      /* scoped */
      const __vue_scope_id__$b = undefined;
      /* module identifier */
      const __vue_module_identifier__$b = undefined;
      /* functional template */
      const __vue_is_functional_template__$b = false;
      /* style inject SSR */
      

      
      var NodeOptions = normalizeComponent_1(
        { render: __vue_render__$b, staticRenderFns: __vue_staticRenderFns__$b },
        __vue_inject_styles__$b,
        __vue_script__$b,
        __vue_scope_id__$b,
        __vue_is_functional_template__$b,
        __vue_module_identifier__$b,
        browser,
        undefined
      );

    //
    var script$c = {
      name: 'NodeAlign',
      components: {
        EditorButton: editorCore.EditorButton
      },
      props: {
        value: {
          type: String
        },
        options: {
          type: Object
        }
      }
    };

    /* script */
    const __vue_script__$c = script$c;

    /* template */
    var __vue_render__$c = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"node-align"},[_c('editor-button',{attrs:{"icon":"align_justify"},on:{"click":function($event){return _vm.$emit('update', '')}}}),_vm._v(" "),_c('editor-button',{attrs:{"icon":"align_left"},on:{"click":function($event){return _vm.$emit('update', 'left')}}}),_vm._v(" "),_c('editor-button',{attrs:{"icon":"align_center"},on:{"click":function($event){return _vm.$emit('update', 'center')}}},[_vm._v(">")]),_vm._v(" "),_c('editor-button',{attrs:{"icon":"align_right"},on:{"click":function($event){return _vm.$emit('update', 'right')}}},[_vm._v(">")])],1)};
    var __vue_staticRenderFns__$c = [];

      /* style */
      const __vue_inject_styles__$c = undefined;
      /* scoped */
      const __vue_scope_id__$c = "data-v-4f2cb78a";
      /* module identifier */
      const __vue_module_identifier__$c = undefined;
      /* functional template */
      const __vue_is_functional_template__$c = false;
      /* style inject */
      
      /* style inject SSR */
      

      
      var NodeAlign = normalizeComponent_1(
        { render: __vue_render__$c, staticRenderFns: __vue_staticRenderFns__$c },
        __vue_inject_styles__$c,
        __vue_script__$c,
        __vue_scope_id__$c,
        __vue_is_functional_template__$c,
        __vue_module_identifier__$c,
        undefined,
        undefined
      );

    function _typeof(obj) {
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function (obj) {
          return typeof obj;
        };
      } else {
        _typeof = function (obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);
      if (staticProps) _defineProperties(Constructor, staticProps);
      return Constructor;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }

      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      });
      if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return self;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (typeof call === "object" || typeof call === "function")) {
        return call;
      }

      return _assertThisInitialized(self);
    }

    var MenuItem$1 =
    /*#__PURE__*/
    function () {
      function MenuItem(label, command, icon) {
        _classCallCheck(this, MenuItem);

        this.label = label;
        this._command = command;
        this.icon = icon;
      }

      _createClass(MenuItem, [{
        key: "isActive",
        value: function isActive(editor) {
          return editor.commands[this.command.name] ? editor.commands[this.command.name](this.command.attrs) : false;
        }
      }, {
        key: "isAvailable",
        value: function isAvailable(editor) {
          return true;
        }
      }, {
        key: "enabled",
        value: function enabled() {}
      }, {
        key: "command",
        value: function command(state) {}
      }, {
        key: "component",
        get: function get() {
          return false;
        }
      }]);

      return MenuItem;
    }();

    var BlockTypeMenu =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(BlockTypeMenu, _MenuItem);

      function BlockTypeMenu() {
        var _this;

        _classCallCheck(this, BlockTypeMenu);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(BlockTypeMenu).call(this));
        _this._items = [];

        _this._items.push({
          label: 'paragraph',
          command: 'paragraph',
          attrs: {}
        });

        return _this;
      }

      _createClass(BlockTypeMenu, [{
        key: "add",
        value: function add(label, command, attrs) {
          if (label instanceof structuredEditorExtensions.Node) {
            label.blockTypes(this);
          } else {
            this._items.push({
              label: label,
              command: command,
              attrs: attrs
            });
          }

          return this;
        }
      }, {
        key: "all",
        value: function all() {
          return this._items;
        }
      }, {
        key: "component",
        get: function get() {
          return BlockTypeSelector;
        }
      }]);

      return BlockTypeMenu;
    }(MenuItem$1);

    var ExtensionMenuItem =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(ExtensionMenuItem, _MenuItem);

      function ExtensionMenuItem(item) {
        _classCallCheck(this, ExtensionMenuItem);

        return _possibleConstructorReturn(this, _getPrototypeOf(ExtensionMenuItem).call(this, item.label, item, item.icon));
      }

      _createClass(ExtensionMenuItem, [{
        key: "command",
        value: function command(editor, attrs) {
          if (!attrs) {
            attrs = {};
          }

          editor.commands[this._command.name](attrs);
        }
      }, {
        key: "isActive",
        value: function isActive(editor) {
          if (structuredEditorUtils.isFunction(this._command.isActive)) {
            return this._command.isActive(editor);
          }

          return editor.isActive[this._command.name]();
        }
      }, {
        key: "isAvailable",
        value: function isAvailable(editor) {
          if (structuredEditorUtils.isFunction(this._command.isAvailable)) {
            return this._command.isAvailable(editor);
          }

          return true;
        }
      }, {
        key: "component",
        get: function get() {
          return this._command.menu;
        }
      }]);

      return ExtensionMenuItem;
    }(MenuItem$1);

    var EditorMenu =
    /*#__PURE__*/
    function () {
      function EditorMenu() {
        _classCallCheck(this, EditorMenu);

        this._items = [];
      }

      _createClass(EditorMenu, [{
        key: "add",
        value: function add(label, command, icon) {
          this._items.push(this.transformItem(label, command, icon));

          return this;
        }
      }, {
        key: "transformItem",
        value: function transformItem(label, command, icon) {
          if (command) {
            command = _typeof(command) === 'object' ? command : {
              command: command
            };
            return new MenuItem$1(label, command, icon);
          } else if (this.isExtension(label)) {
            return new ExtensionMenuItem(label);
          } else if (structuredEditorUtils.isFunction(label)) {
            return label();
          } else {
            return label;
          }
        }
      }, {
        key: "isExtension",
        value: function isExtension(item) {
          return item && (item instanceof structuredEditorExtensions.Node || item instanceof structuredEditorExtensions.Mark || item instanceof structuredEditorExtensions.Extension);
        }
      }, {
        key: "all",
        value: function all() {
          return this._items;
        }
      }]);

      return EditorMenu;
    }();

    var MenuDivider =
    /*#__PURE__*/
    function (_MenuItem) {
      _inherits(MenuDivider, _MenuItem);

      function MenuDivider() {
        _classCallCheck(this, MenuDivider);

        return _possibleConstructorReturn(this, _getPrototypeOf(MenuDivider).call(this, null, null, null));
      }

      _createClass(MenuDivider, [{
        key: "command",
        value: function command(state) {
          return true;
        }
      }, {
        key: "component",
        value: function component() {
          return MenuSeparator;
        }
      }]);

      return MenuDivider;
    }(MenuItem$1);

    var InsertMenuCollection =
    /*#__PURE__*/
    function (_EditorMenu) {
      _inherits(InsertMenuCollection, _EditorMenu);

      function InsertMenuCollection() {
        var _this;

        _classCallCheck(this, InsertMenuCollection);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(InsertMenuCollection).call(this));
        _this._quick = [];
        _this.settings = {
          collapse: 200
        };
        return _this;
      }

      _createClass(InsertMenuCollection, [{
        key: "set",
        value: function set(setting, value) {
          this.settings[setting] = value;
          return this;
        }
      }, {
        key: "quick",
        value: function quick(label, icon, command) {
          var item = this.transformItem(label, icon, command);

          this._quick.push(item);

          this._items.push(item);

          return this;
        }
      }, {
        key: "quickItems",
        value: function quickItems() {
          return this._quick;
        }
      }]);

      return InsertMenuCollection;
    }(EditorMenu);

    exports.BlockMenu = BlockMenu;
    exports.BlockTypeMenu = BlockTypeMenu;
    exports.BlockTypeSelector = BlockTypeSelector;
    exports.EditorMenu = EditorMenu;
    exports.ExtensionMenuItem = ExtensionMenuItem;
    exports.InsertMenu = InsertMenu;
    exports.InsertMenuCollection = InsertMenuCollection;
    exports.MenuBar = MenuBar;
    exports.MenuDivider = MenuDivider;
    exports.MenuDropButton = MenuDropButton;
    exports.MenuItem = MenuItem;
    exports.MenuItemCollection = MenuItem$1;
    exports.MenuSeparator = MenuSeparator;
    exports.NodeAlign = NodeAlign;
    exports.NodeOptions = NodeOptions;
    exports.NodeResizer = NodeResizer;
    exports.SelectionMenu = SelectionMenu;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
